<?php

class rex_a338_liveEdit
{
  var $templatePath;
  var $modulePath;
  
  function rex_a338_liveEdit() 
  {
    global $REX;
    $this->templatePath = $REX['INCLUDE_PATH']."/addons/developer/live-edit/templates/";
    $this->modulePath = $REX['INCLUDE_PATH']."/addons/developer/live-edit/modules/";
  }
  
  function generateTemplateFiles() 
  {
    global $REX;
    rex_deleteDir($this->templatePath, 0);
    $sql = new rex_sql;
    $sql->setQuery('SELECT id,name,content FROM '.$REX['TABLE_PREFIX'].'template');
    for ($i=0; $i<$sql->getRows(); $i++) {
      $filename = rex_a338_liveEdit::_getFilename($sql->getValue('id').'.'.$sql->getValue('name').".template.php");
      $file = $REX['INCLUDE_PATH']."/addons/developer/live-edit/templates/".$filename;
      rex_put_file_contents($file, $sql->getValue('content'));
      $sql->next();
    }
  }

  function generateModuleFiles() 
  {
    global $REX;
    rex_deleteDir($this->modulePath, 0);
    $sql = new rex_sql;
     $sql->setQuery('SELECT id,name,ausgabe,eingabe FROM '.$REX['TABLE_PREFIX'].'module');
    for ($i=0; $i<$sql->getRows(); $i++) {
      $filename = rex_a338_liveEdit::_getFilename($sql->getValue('id').'.output.'.$sql->getValue('name').".module.php");
      $file = $this->modulePath.$filename;
      rex_put_file_contents($file, $sql->getValue('ausgabe'));
      $filename = rex_a338_liveEdit::_getFilename($sql->getValue('id').'.input.'.$sql->getValue('name').".module.php");
      $file = $this->modulePath.$filename;
      rex_put_file_contents($file, $sql->getValue('eingabe'));
      $sql->next();
    }
  }
  
  function syncTemplates()
  {
    global $REX,$REX_LOGIN;
    $files = $this->getTemplateFiles();
    require_once $REX['INCLUDE_PATH']."/functions/function_rex_generate.inc.php";
    rex_deleteDir($REX['INCLUDE_PATH']."/generated/templates", 0);
    if (is_array($files))
      foreach ($files as $filename) {
        $sql = new rex_sql();
        //$sql->debugsql = true;
        $id = $this->_getId($filename);
        $sql->setQuery('SELECT updatedate FROM '.$REX['TABLE_PREFIX'].'template WHERE id = '.$id);
        if ($sql->getRows()>0) {
          $file = $this->templatePath.$filename;
          if (filemtime($file) > $sql->getValue('updatedate')) {
            $content = addslashes(rex_get_file_contents($file));
            $content = $content == '' ? ' ' : $content;
            $sql->setTable($REX['TABLE_PREFIX']."template");
            $sql->setWhere("id = '$id'");
            $sql->setValue('content',$content);
            $sql->setValue('updatedate',time());
            #$REX_LOGIN = new rex_backend_login($REX['TABLE_PREFIX'].'user');
            #if ($REX_LOGIN->message=='')
            $sql->setValue('updateuser',$REX_LOGIN->USER->getValue('login'));
            $sql->update();
            //unlink($REX['INCLUDE_PATH']."/generated/templates/$id.template");
            /*rex_generateTemplate($id);*/
            /* foreach($REX['VARIABLES'] as $var) {
  		        $content = $var->getTemplate($content);
  	        }
            rex_put_file_contents($REX['INCLUDE_PATH']."/generated/templates/$id.template", stripslashes($content)); */
          }
        } 
      }
  }
  
  function syncModules()
  {
    global $REX,$REX_LOGIN;
    $files = $this->getModuleFiles();
    if (is_array($files))
      foreach ($files as $filename) {
        $sql = new rex_sql();
        //$sql->debugsql = true;
        $id = $this->_getId($filename);
        $sql->setQuery('SELECT updatedate FROM '.$REX['TABLE_PREFIX'].'module WHERE id = '.$id);
        if ($sql->getRows()>0) {
          $fileInput = $this->modulePath.$filename;
          $fileOutput = $this->modulePath.str_replace('.input.','.output.',$filename);
          $changed = false;
          if (filemtime($fileInput) > $sql->getValue('updatedate')) {
            $input = addslashes(rex_get_file_contents($fileInput));
            $sql->setValue('eingabe',$input);
            $changed = true;
          }
          if (filemtime($fileOutput) > $sql->getValue('updatedate')) {
            $output = addslashes(rex_get_file_contents($fileOutput));
            $sql->setValue('ausgabe',$output);
            $changed = true;
          }
          if ($changed) {
            $sql->setTable($REX['TABLE_PREFIX']."module");
            $sql->setWhere("id = '$id'");
            $sql->setValue('updatedate',time());
            #$REX_LOGIN = new rex_backend_login($REX['TABLE_PREFIX'].'user');
            #if ($REX_LOGIN->checkLogin())
            $sql->setValue('updateuser',$REX_LOGIN->USER->getValue('login'));
            $sql->update();
            $gc = new rex_sql;
            //$gc->debugsql = true;
            $gc->setQuery("SELECT DISTINCT(".$REX['TABLE_PREFIX']."article.id) FROM ".$REX['TABLE_PREFIX']."article
              LEFT JOIN ".$REX['TABLE_PREFIX']."article_slice ON ".$REX['TABLE_PREFIX']."article.id=".$REX['TABLE_PREFIX']."article_slice.article_id
              WHERE ".$REX['TABLE_PREFIX']."article_slice.modultyp_id='$id'");
            for ($i=0; $i<$gc->getRows(); $i++) {
              require_once $REX['INCLUDE_PATH']."/functions/function_rex_generate.inc.php";
          	  rex_deleteCacheArticle($gc->getValue($REX['TABLE_PREFIX']."article.id"));
              $gc->next();
            }
          }
        }
      }
  }
  
  function getTemplateFiles()
  {
    if ($handle = opendir($this->templatePath)) {
      while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != "..") 
          $templateFiles[] = $file;
      }
      closedir($handle);
      return $templateFiles;
    }
  }
  
  function getModuleFiles()
  {
    if ($handle = opendir($this->modulePath)) {
      $templateFiles = array();
      while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != ".." && strpos($file,'.input.')!==false) 
          $templateFiles[] = $file;
      }
      closedir($handle);
      return $templateFiles;
    }
  }
  
  function _getFilename($filename) 
  {
    global $REX;
    $NFILENAME = strtolower($filename);
    $NFILENAME = str_replace(array('','', '', ''),array('ae', 'oe', 'ue', 'ss'),$NFILENAME);
    $NFILENAME = preg_replace('/[^a-zA-Z0-9.\-\+]/','_',$NFILENAME);
    return $NFILENAME;
  }
  
  function _getId($filename)
  {
    return (int) substr($filename,0,strpos($filename,'.'));
  }

}

?>