<?php

function rex_a338_checkNewTemplatesAndModules()
{
  $page = rex_request('page','string','');
  $function = rex_request('function','string','');
  $save = rex_request('save','string','');
  
  if ($page=='template') {
    if ((($function=='add' || $function=='edit') && $save=='ja') || $function=='delete') {
      $liveEdit = new rex_a338_liveEdit();
      $liveEdit->generateTemplateFiles();      
    }
  } elseif ($page=='module' && rex_request('subpage','string','')=='') {    
    if ((($function=='add' || $function=='edit') && $save=='ja') || $function=='delete') {
      $liveEdit = new rex_a338_liveEdit();
      $liveEdit->generateModuleFiles();      
    }  
  }
}

function rex_a338_sync()
{
  global $REX;
  $liveEdit = new rex_a338_liveEdit();
  if ($REX['ADDON']['developer']['status']['templates'] == 1)
    $liveEdit->syncTemplates();
  if ($REX['ADDON']['developer']['status']['modules'] == 1)
    $liveEdit->syncModules(); 
}

function rex_a338_backendEdit($params) 
{
  global $REX, $REX_USER, $I18N_DEVELOPER, $page;
  if (isset($REX_USER) && ((rex_get('install','int')!=1 && rex_get('activate','int')!=0) || rex_get('addonname','string')!='developer')) {
    if ($REX_USER->hasPerm("developer[]")) {
      $template_checked = $REX['ADDON']['developer']['status']['templates'] == 1 ? ' checked' : '';
      $module_checked = $REX['ADDON']['developer']['status']['modules'] == 1 ? ' checked' : '';
      $output = '
          <form action="index.php?page='.$page.'" method="post" id="rex-a338">
            <input type="hidden" name="developer_new_status" value="1" />
            '.$I18N_DEVELOPER->msg('developer_name').': &nbsp;&nbsp;&nbsp;
            <input type="checkbox" id="rex-a338-templates" name="developer_status_templates" value="1" onchange="this.form.submit();"'.$template_checked.' /> 
            <label for="rex-a338-templates">'.$I18N_DEVELOPER->msg('developer_templates').'</label> &nbsp;&nbsp;&nbsp;
            <input type="checkbox" id="rex-a338-modules" name="developer_status_modules" value="1" onchange="this.form.submit();"'.$module_checked.' /> 
            <label for="rex-a338-modules">'.$I18N_DEVELOPER->msg('developer_modules').'</label> 
            <noscript>&nbsp;&nbsp;&nbsp;<input type="submit" value="OK" /></noscript>
          </form>';
      return str_replace('<div id="rex-ftr">','<div id="rex-ftr">'.$output,$params['subject']);
    }
  }
  return $params['subject'];
}

function rex_a338_addCSS($params) 
{
 global $REX, $REX_USER;
  if (isset($REX_USER) && ((rex_get('install','int')!=1 && rex_get('activate','int')!=0) || rex_get('addonname','string')!='developer'))
    if ($REX_USER->hasPerm("developer[]"))
      return $params['subject'].'  <link rel="stylesheet" type="text/css" href="index.php?css=addons/developer" />'."\n";
}

function rex_a338_setStatus($templates, $modules) 
{
  global $REX;
  $content = "\$REX['ADDON']['developer']['status']['templates'] = $templates;\n";
  $content .= "\$REX['ADDON']['developer']['status']['modules'] = $modules;\n";
  $file = $REX['INCLUDE_PATH']."/addons/developer/config.inc.php";
  rex_replace_dynamic_contents($file, $content);
}

function rex_a338_generateFiles()
{
  $liveEdit = new rex_a338_liveEdit();
  $liveEdit->generateTemplateFiles();
  $liveEdit->generateModuleFiles();
}

?>